import mx.central.Shell;
import mx.controls.TextArea;
import mx.central.RegExp;

class HTMLFormat implements mx.central.Application {
    
    var shell:Shell;
    var unformatted_txt:TextArea;
    var formatted_txt:TextArea;

    function HTMLFormat(unformatted:TextArea, formatted:TextArea) {
        unformatted_txt = unformatted;
        formatted_txt = formatted;
    }
    /**********************************************
     *            Central functions                *
     ***********************************************/

    // Called by Central once your application has loaded.
	function onActivate (shell:Shell, appID:Number, shellID:Number, baseTabindex:Number, initiaData:Object):Void
	{
        this.shell = shell;
        //Some text to do search and replace on. 
        unformatted_txt.text = "This example uses a number of " +
            "regular expressions to turn plain text into HTML formatted " +
            "text suitable for adding to a text field with HTML " + 
            "rendering enabled.\n\r" +
            
            "Supported features are: \n" + 
            "Replace the following characters with their HTML entity " +
            "equivalents: <,>,&,\",\'\n" +
            "Turn email addreses, such as someone@macromedia.com, and " +
            "http urls, such as http://www.macromedia.com/software/central" +
            ", into links\n" + 
            "Replace newlines with <br> tags."
    }


    // Called by Central when the application is about to be unloaded / closed.
	function onDeactivate (Void):Void
    {
        //add clean up code here (such as closing network connections, delete variables
        //place in _global)
    }


	// Called when the application is resized. The application should resize
	// itself accordingly
	function onResize (Void):Void
    {
        var bounds = this.shell.getBounds();
    }


    // called by Central to determine the Minimum size your application can be resized to.
    // If there is no need to specify a  minimum size, you can remove this method.
	function getMinimumSize (Void):Object
    {
        // set the properties below to your Maximum size.
        return {width:200, height:200};
    }


    // Called by Central when the application is about to be un-installed
	function onUninstall (Void):Void
    {
    }

	function onNoticeEvent (event:Object, noticeData:Object, initalData:Object):Void {}
	function onNetworkChange (connected:Boolean):Void {}
	function onPaymentResult (result:Boolean, transactionID:Object):Void {}
	function onSelectedItem (data:Array):Void {}
	function showPreferences (Void):Void {}

    //Apply HTML formatting to some plain text 
    function formatText() {
        //get the text to be formatted
        var htmlText:String = unformatted_txt.text; 

        //Replace characters with their HTML entity equivalents
        htmlText = htmlText.replace("&", "&amp;"); 
        htmlText = htmlText.replace("<", "&lt;"); 
        htmlText = htmlText.replace(">", "&gt;"); 
        htmlText = htmlText.replace("\"", "&quot;"); 
        htmlText = htmlText.replace("'", "&apos;"); 
	
        //convert newlines to <br> tags 
        htmlText = htmlText.replace("(\n\r|\n|\f)", "<br>"); 
	
        //Create the regular expression string to find email addresses
        // in the text. 
        // Note that you must double escape characters, this is because
        // the regexp is treated like a string
        var matchEmail:String = "\\b(\\w[-.\\w]*\\@[-a-z0-9]+(\\.[-a-z0-9]+)*\\.(com|org|edu|info))\\b";
            
        // Create a new RegExp object using our regular expression
        // string. Set the global flag, "g", so that we do not begin an
        // new search each time we call exec and create an endless loop
        var findEmail:RegExp = new RegExp(matchEmail, "g");
        
        // create a copy of our original text which will be modified
        // as we loop over the original
        var swapText:String = htmlText;
        
        // keep running the regular expression, until we run out of
        // matches
        while (true) {
            // run the regular expression, assign the result (our
            // found text) to a variable
            var match:Object = findEmail.exec(htmlText);
            
            //if we didn't find a match, exit the loop
            if (match == undefined) {
                break;
            }
            
            //Call String.replace() on our backup copy of the text. We
            //use the email address that we already know is there as
            //the search string, and this gets replaced with a HTML
            //formatted version of the same string. 
            swapText = swapText.replace(match[0], "<u><a href='mailto:" +
                                        match[0] + "'>" + match[0] +
                                        "</a></u>");
            
            //debug code - print out the email address
            trace(match[0]); 
        }
        
        // overwrite the original text with the modified version and
        // clear out swapText variable for later use
        htmlText = swapText; 
        swapText =""; 
	
        // Create the regular expression string to find http urls in the text. 
        var matchURL:String = "\\b(https?://[-a-z0-9]+(\\.[-a-z0-9]+)*\\.(com|org|edu|info|net|biz)\\b(/[-a-z0-9_:\\@&?=+,.!/~*'%\\$]*(?<![.,?!]))?)";
        // Create a new RegExp object from the regular expression
        // string. Remember to set the global flag
        var findURL:RegExp = new RegExp(matchURL, "g");
        
        // create a copy of the original text 
        swapText = htmlText;
        
        // keep running the regular expression, until we run out of matches
        while (true) {
            // run the regular expression, assign the result (our
            // found text) to a variable
            var match:Object = findURL.exec(htmlText);
            
            //if we didn't find a match, exit the loop
            if (match == undefined) {
                break;
            }
            
            // Use the string.replace method to replace the
            // unformatted url with a HTML formatted version of the
            // same url
            swapText = swapText.replace(match[0], "<u><a href='" + match[0] + "'>" + match[0] + "</a></u>");
            //debug code - print out the http url
            trace(match[0]); 
        }
        
        //overwrite the original text with the version that we modified
        htmlText = swapText;
        
        // write the formatted text to the htmlText field of the HTML
        // enabled text field. Note that it is safe to assign HTML text
        // to the .text property because the .html parameter is true
        formatted_txt.text = htmlText;
        
        //debugging - print out the final formatted version of our text 
        trace(htmlText); 
    }

    function loadFile(Void) {
        var fileRef = new FileReference();
        if (!fileRef.browse(["Text Files", "*.txt;*.ini"]))
			return;

		// now load the file
		unformatted_txt.text = fileRef.readFile();
    }

    function saveHtml(Void) {

        // we must write to the file while it is in the local internet
        // cache, then we can move it elsewhere.
        var fileRef = new FileReference();
        fileRef.create("TempOutput.html");
        fileRef.writeString(formatted_txt.text);

        // don't pass any parameters to move - it will ask the user
        // for a new location
        fileRef.move();
    }
}

